%% GC gestion de classe. Copyright 2001 vincent LEDDA. Licensed 
%% under the GNU General Public License (GPL). See the file COPYING for full
%% details of this license. 


\NeedsTeXFormat{LaTeX2e}[1995/12/01]
\ProvidesClass{exo}[2003/20/02 v0.6 Une classe pour des exos de math]
\LoadClassWithOptions{article}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  Dpendances %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\RequirePackage[latin1]{inputenc}
\RequirePackage[T1]{fontenc}
\RequirePackage[frenchb]{babel}
\RequirePackage{array,calc,epsfig,amsthm,amsmath,amssymb,ifthen,vmargin,multicol,keyval,picins}
\RequirePackage{graphics,eurosym}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Dimensions et compteurs %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\newdimen\largeur
\newcount\mode
\newcount\logoE
\newcount\Ent
\newcounter{Itemm}

\newdimen\saut
\saut= 1.5mm
\Ent= 0
\logoE= 0
\setlength\columnsep{20mm}
\setlength\columnseprule{0.4pt}

\setlength{\largeur}{\textwidth}
\pagestyle{empty}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Options %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\DeclareOption{A4}{%
\setpapersize{A4}
\setmargins{10mm}{10mm}{190mm}{277mm}{0mm}{0mm}{0mm}{0mm}
\setlength\largeur{\textwidth}
\mode= 1
}

\DeclareOption{A4r}{%
\setpapersize[landscape]{A4}
\setmargins{10mm}{10mm}{277mm}{190mm}{0mm}{0mm}{0mm}{0mm}
\setlength\largeur{\textwidth}
\mode= 1
}

\DeclareOption{A4R}{%
\setpapersize[landscape]{A4}
\setmargins{10mm}{10mm}{277mm}{190mm}{0mm}{0mm}{0mm}{0mm}
\setlength\largeur{127.5mm}
\mode= 4
}

\DeclareOption{A5}{%
\setpapersize[landscape]{A4}
\setmargins{10mm}{10mm}{277mm}{190mm}{0mm}{0mm}{0mm}{0mm}
\setlength\largeur{127.5mm}
\mode= 2
}

\DeclareOption{A6}{%
\setpapersize[landscape]{A4}
\setmargins{10mm}{10mm}{277mm}{190mm}{0mm}{0mm}{0mm}{0mm}
\setlength\largeur{127.5mm}
\mode= 3
}

%les commandes en majuscules sont  protger
\DeclareOption{logo}{%
\logoE= 1
\addtolength{\saut}{14.5mm}
\newcommand{\Logo}{logo.eps}
\newcommand{\logo}[1]{\renewcommand{\Logo}{#1}}
}

\DeclareOption{DNS}{%
\Ent= 1
\newcommand{\Arendrele}{\`A rendre le \today}
\newcommand{\arendrele}[1]{\renewcommand{\Arendrele}{\`A rendre le #1}}
\newcommand{\intitule}{Devoir non surveill}
\newcommand{\ephe}{\Classe \hfill \Arendrele }

}

\DeclareOption{DS}{%
\Ent= 1
\newcommand{\Duree}{Dure~:1 heure}
\newcommand{\duree}[1]{\renewcommand{\Duree}{Dure~: #1}}
\newcommand{\Date}{\today}
\newcommand{\ladate}[1]{\renewcommand{\Date}{#1}}
\newcommand{\intitule}{Devoir surveill}
\newcommand{\ephe}{{\Classe \hfill \Date \hfill \Duree\\}}
}
\DeclareOption{BAC}{%
\Ent= 1
\newcommand{\Duree}{Dure~:1 heure}
\newcommand{\duree}[1]{\renewcommand{\Duree}{Dure~: #1}}
\newcommand{\Date}{\today}
\newcommand{\ladate}[1]{\renewcommand{\Date}{#1}}
\newcommand{\intitule}{Baccalaurat blanc}
\newcommand{\ephe}{{\Classe \hfill \Date \hfill \Duree\\}}
}
\DeclareOption{TEST}{%
\Ent= 1
\newcommand{\Duree}{Dure~:1 heure}
\newcommand{\duree}[1]{\renewcommand{\Duree}{Dure~: #1}}
\newcommand{\Date}{\today}
\newcommand{\ladate}[1]{\renewcommand{\Date}{#1}}
\newcommand{\intitule}{Test de mathmatiques}
\newcommand{\ephe}{{\Classe \hfill \Date \hfill \Duree\\}}
}

\DeclareOption{INT}{%
\Ent= 1
\newcommand{\Duree}{Dure~:1 heure}
\newcommand{\duree}[1]{\renewcommand{\Duree}{Dure~: #1}}
\newcommand{\Date}{\today}
\newcommand{\ladate}[1]{\renewcommand{\Date}{#1}}
\newcommand{\intitule}{Interrogation}
\newcommand{\ephe}{{\Classe \hfill \Date \hfill \Duree\\}}
}
\DeclareOption{11pt}{\fontsize{11}{12}\selectfont}
\DeclareOption{12pt}{\fontsize{12}{14.5}\selectfont}
\DeclareOption{10pt}{\fontsize{10}{13.6}\selectfont}
\DeclareOption{8pt}{\fontsize{4}{10.7}\selectfont}

\ExecuteOptions{A4,11pt}
\ProcessOptions\relax


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Commandes %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\newcommand{\Classe}{}
\newcommand{\classe}[1]{\renewcommand{\Classe}{#1}}
\newcommand{\Num}{}
\newcommand{\num}[1]{\renewcommand{\Num}{\ #1}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Environnements %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\newcounter {Exercices}
\setcounter{Exercices}{1}
\newenvironment{exercice}[1][0]{\noindent{\large\bfseries\underline{Exercice \theExercices}~}\ifthenelse{\equal{#1}{0}}{}{\textit{(
 #1\;\ifthenelse{\equal{#1}{1}}{point}{points})\,}} }{\par\stepcounter{Exercices}\vspace{1mm}}
\newenvironment{exercice*}[1][0]{\noindent{\large\bfseries\underline{Exercice}~}\ifthenelse{\equal{#1}{0}}{}{\textit{( #1\;\ifthene
lse{\equal{#1}{1}}{point}{points})\,}} }{\par\stepcounter{Exercices}\vspace{1mm}}
    
\newcounter {Problemes}
\setcounter{Problemes}{1}
\newenvironment{probleme}{{\large\bfseries PROBL\`EME \Roman{Problemes}}\vspace{2mm}\\}{\par\setcounter{Parties}{1}\stepcounter{Problemes}}
\newenvironment{probleme*}{{\large\bfseries PROBL\`EME}\vspace{2mm}\\}{\par\setcounter{Parties}{1}\stepcounter{Problemes}}

\newcounter {Questions}
\setcounter{Questions}{1}
\newenvironment{question}{{\large\bfseries QUESTION  \Roman{Questions}}\vspace{2mm}\\}{\par\setcounter{Parties}{1}\stepcounter{Questions}}
\newenvironment{question*}{{\large\bfseries
    QUESTION}\vspace{2mm}\\}{\par\setcounter{Parties}{1}\stepcounter{Questions}}

\newcounter {Parties}
\setcounter{Parties}{1}
\newenvironment{partie}{\noindent{\bfseries\framebox{\Roman{Problemes}.\Alph{Parties}}~}\\}{\stepcounter{Parties}}
\newenvironment{partie*}{\noindent{\bfseries Partie \Alph{Parties}~}\\}{\stepcounter{Parties}}


\newenvironment{remarque}{\begin{center}\itshape}{\end{center}}

\newsavebox{\Enonce}
\newcommand{\Encore}{\hspace{10mm}\usebox{\Enonce}\par}
\newenvironment{enonce}{\begin{lrbox}{\Enonce}\begin{minipage}[b]{\largeur}}{%
\end{minipage}\end{lrbox}\Encore
\ifthenelse{\mode =2}{\Encore}{}
\ifthenelse{\mode =3}{\Encore\Encore\Encore}{}
}

\newcommand{\entete}{%
\ifthenelse{\logoE =1}{\addtolength{\largeur}{-22mm}}{}
\raisebox{\saut}[5mm][2mm]{\framebox[\largeur]{\ephe}}
\ifthenelse{\mode =  3}{\raisebox{\saut}[4mm][2mm]{\centerline{\Large\bf \intitule \Num}}}{\raisebox{\saut}[5mm][0mm]{\centerline{\Large\bf  \intitule \Num}}}
\ifthenelse{\logoE =1}{\addtolength{\largeur}{22mm}\vspace{-1cm}\par}{}
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Nouvelles commandes graphiques %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%% variables

\newlength\figh
\newlength\figw
\newlength\coeff
\def\echelle{1}
\def\format{eps}
\def\position{l}
\def\decoration{}
\def\style{\arabic}
\newsavebox{\Figureb}
\newdimen\total
\newdimen\reste
\newdimen\ligneskip
\setlength\ligneskip{\baselinestretch\baselineskip}
%\showthe\largeur
%\showthe\baselineskip
%\showthe\baselinestretch



%%%% options
\define@key{param}{position}{\def\position{#1}}
\define@key{param}{enumstyle}{\def\enumstyle{#1}}
\define@key{param}{decoration}{\def\decoration{#1}}
\define@key{param}{hauteur}{\setlength{\figh}{#1}}
\define@key{param}{format}{\def\format{#1}}
\define@key{param}{enumstyle}{\ifthenelse{\equal{#1}{r}}{\def\style{\roman}}{\ifthenelse{\equal{#1}{R}}{\def\style{\Roman}}{\ifthenelse{\equal{#1}{a}}{\def\style{\arabic}}{\ifthenelse{\equal{#1}{al}}{\def\style{\alph}}{\ifthenelse{\equal{#1}{Al}}{\def\style{\Alph}}{}}}}}}
\define@key{param}{largeur}{\setlength{\figw}{#1}}
\define@key{param}{echelle}[1]{\def\echelle{#1}}




%%%% commandes

\newenvironment{Figures}[2]{\setkeys{param}{#1}%
\setcounter{Itemm}{1}%
\renewcommand{\item}{\ifthenelse{%
\equal{\theItemm}{1}}{%
{\quad\style{Itemm}.\;\;\stepcounter{Itemm}}}{%
\hfill\break$\mbox{}${\quad\style{Itemm}.\;\;\stepcounter{Itemm}}}}%
\begin{lrbox}{\Figureb}\begin{minipage}[h]{\largeur}\parpic(\figw,\figh)[\position\decoration]{\parbox[b]{\figw}{\placeimage{\format}{#2}}}}{\par\renewcommand{\item}{
        \@inmatherr\item  \@ifnextchar [\@item{\@noitemargtrue
          \@item[\@itemlabel]}}\end{minipage}\end{lrbox}%
\usebox{\Figureb}%
\setlength\total{\ht\Figureb + \dp\Figureb}%
\setlength\reste{\figh-\total}%

%\showthe\reste
%\showthe\figh
%\showthe\dp\Figureb
%\showthe\ht\Figureb
%\showthe\total

\ifthenelse{\lengthtest{\reste > 0pt }}{%
\par\vspace{\reste}}\par{%
 \ifthenelse{\lengthtest{\reste > -5\ligneskip  }}{%
   \vspace{\ligneskip}\par}{\par}}%
}


%A protger
\newcommand{\placeimage}[2]{%
\ifthenelse{\equal{#1}{pstex}}{%
  \scalebox{\echelle}{\resizebox{\figw}{\figh}{\input{#2}}}}{%
  \ifthenelse{\equal{#1}{eps}}{%
    \includegraphics[scale=\echelle,
    keepaspectratio=true,width=\figw,height=\figh]{#2}}{%
  \scalebox{\echelle}{\resizebox{\figw}{\figh}{#2}}}}
}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Nouveaux environments pour les cours %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\newtheorem{Thm}{Thorme}
\newtheorem{pro}{Proposition}
\newtheorem{lem}{Lemme}
\newtheorem{Def}{Dfinition}
\newtheorem{cor}{Corollaire}
\newtheorem{exem}{Exemple}
\newtheorem{rem}{Remarque}
\newtheorem{rap}{Rappels}
\newcommand{\danger}{\dbend}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Dbut&fin %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\AtBeginDocument{\ifthenelse{\mode = 1}{}{\ifthenelse{\mode =4}{\setlength\columnsep{10mm}\begin{multicols}{2}}{\setlength{\parindent}{-10mm}\begin{multicols}{2}\begin{enonce}}}

\ifthenelse{\logoE = 0}{}{
\setlength{\unitlength}{1mm} 
\begin{picture}(20,20)(10,10)
\put(10,10){\includegraphics{\Logo}}
 \end{picture}
}
\ifthenelse{\Ent = 1}{\entete}{}}

\AtEndDocument{\ifthenelse{\mode = 1}{}{\ifthenelse{\mode = 4}{\end{multicols}}{\end{enonce}\end{multicols}}}}
